--[[
  MTarget Version 1.0.1 - Menu Functions ($Id$)
  Written by gameldar
  http://www.wowace.com/projects/mtarget

  Thanks to:
    Ace3: Great lib framework
  ]]--


local AceGUI = LibStub("AceGUI-3.0");

local L = LibStub("AceLocale-3.0"):GetLocale("MTarget", true);

function MTarget:Menu_OnInitialize()
  LibStub:GetLibrary("LibDataBroker-1.1"):NewDataObject("MTarget", {
	    type = "launcher",
	    icon = "Interface\\Icons\\Ability_Hunter_MasterMarksman",
	    OnClick = function(clickedframe, button)
	        MTarget:Menu_Show();
	    end,
	});
  self:Menu_Create();
end

function MTarget:Menu_CreateDialogs()
  StaticPopupDialogs["MTarget_SetVariableString"] = {
    text = L["Set variable name and value string (e.g. spell=Exorcism)"],
    button1 = L["Set"],
    button2 = L["Cancel"],
    hasEditBox = 1,
    whileDead = 1,
    hideOnEscape = 1,
    timeout = 0,
    OnShow = function()
      getglobal(this:GetName().."EditBox"):SetText("x=y");
    end,
    OnAccept = function()
      variable = getglobal(this:GetParent():GetName().."EditBox"):GetText();
      MTarget:SetVariableString(variable);
    end
  };
  
end

function MTarget:Menu_Create()
  menu = AceGUI:Create("Frame")
--  menu:SetCallback("OnClose",function(widget) AceGUI:Release(widget) end)
  menu:SetLayout("Flow")
  -- Create a button
  for i = 1, #MTarget.commands do
    local item = MTarget.commands[i];
    if (item.menu) then
      local btn = AceGUI:Create("Button");
      btn:SetWidth(170);
      btn:SetText(item.menu);
      local func = "Console_Cmd_" .. (item.func or item.id);
      if (item.dialog) then
        func = "MTarget_Dialog_" .. (item.func or item.id);
      end
      btn:SetCallback("OnClick", function ()
          menu:Hide();
          if (item.dialog) then
            StaticPopup_Show(func);
          else
            MTarget[func]();
          end
        end);
        --[[
      btn:SetCallback("OnEnter", function ()
        GameTooltip:SetOwner(btn, "ANCHOR_NONE");
        GameTooltip:SetPoint("TOPLEFT", btn, "BOTTOMLEFT");
        GameTooltip:ClearLines();
        GameTooltip:AddLine(item.desc);
        GameTooltip:Show();
      end);
        btn:SetCallback("OnLeave", function ()
          GameTooltip:Hide();
        end);
      ]]--
      -- Add the button to the container
      menu:AddChild(btn);
    end
  end
  MTarget.menu = menu;
  menu:Hide();
end

function MTarget:Menu_Show()
  MTarget:Debug("Showing Menu...");
  MTarget.menu:Show();
end
